package com.zyh.common.domain;

import lombok.Data;
import com.alibaba.excel.annotation.ExcelProperty;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.Date;

@Data
public class Person {
    @ExcelProperty("编号")
    private Integer id;
    @ExcelProperty("姓名")
    @NotEmpty(message = "姓名不能为空")
    private String name;
    @ExcelProperty("身份证号")
    @NotEmpty(message = "身份证号不能为空")
    private String idcard;
    @ExcelProperty("身份证类型编号")
    @NotNull(message = "身份证类型不能为空")
    private Integer idcardType;
    @ExcelProperty("出生日期")
    @NotEmpty(message = "出生日期不能为空")
    private String birth;
    @ExcelProperty("民族")
    @NotEmpty(message = "民族不能为空")
    private String nation;
    @ExcelProperty("性别")
    @NotNull(message = "性别不能为空")
    private Integer sex;
    @ExcelProperty("手机号")
    @NotEmpty(message = "手机号不能为空")
    private String phone;
    @ExcelProperty("户籍")
    @NotEmpty(message = "户籍不能为空")
    private String address;
    @ExcelProperty("小区id")
    @NotEmpty(message = "小区不能为空")
    private String houseId;
    @ExcelProperty("楼栋id")
    @NotNull(message = "楼栋不能为空")
    private Integer buildId;
    @ExcelProperty("单元")
    @NotNull(message = "单元不能为空")
    private Integer unit;
    @ExcelProperty("房号")
    @NotNull(message = "房号不能为空")
    private Integer holdId;
    @ExcelProperty("身份证照片")
    @NotEmpty(message = "身份证照片不能为空")
    private String pic;

    private String housename;

}
