package com.zyh.common.util;

import com.zyh.common.domain.CompreFaceApiResponse;
import com.zyh.common.result.Result;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;


import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;




import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Base64;
import java.util.List;

public class ComprefaceUtils {

    private static final String BASE_URL = "http://100.96.85.95:8000";
    private static final String VERIFICATION_API_KEY = "1596cf9c-8426-41bf-ad3e-cb3b126533ab";

//    public static String verifyFace(String base64Image, String limit, String detProbThreshold, String facePlugins, String status) {
//        try {
//            // 对参数进行 URL 编码
//            limit = URLEncoder.encode(limit, StandardCharsets.UTF_8);
//            detProbThreshold = URLEncoder.encode(detProbThreshold, StandardCharsets.UTF_8);
//            facePlugins = URLEncoder.encode(facePlugins, StandardCharsets.UTF_8);
//            status = URLEncoder.encode(status, StandardCharsets.UTF_8);
//
//            // 构建请求URL
//            String apiUrl = BASE_URL + "/api/v1/verification/verify?limit=" + limit +
//                    "&det_prob_threshold=" + detProbThreshold + "&face_plugins=" + facePlugins +
//                    "&status=" + status;
//
//            // 构建请求头
//            HttpClient httpClient = HttpClients.createDefault();
//            HttpPost httpPost = new HttpPost(apiUrl);
//            httpPost.setHeader("Content-Type", "application/json");
//            httpPost.setHeader("x-api-key", VERIFICATION_API_KEY);
//
//            // 构建请求体
//            String requestBody = "{\"base64Image\":\"" + base64Image + "\"}";
//            httpPost.setEntity(new StringEntity(requestBody, ContentType.APPLICATION_JSON));
//
//            // 发送请求并获取响应
//            HttpResponse response = httpClient.execute(httpPost);
//            HttpEntity entity = response.getEntity();
//
//            // 处理响应
//            if (entity != null) {
//                return EntityUtils.toString(entity);
//            }
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//
//        return null;
//    }

    public static Result<CompreFaceApiResponse.Result> recognizeFace(byte[] imageData) {
        try {
            String apiUrl = BASE_URL + "/api/v1/recognition/recognize?limit=0&det_prob_threshold=0.8&prediction_count=1&face_plugins=landmarks%2C%20gender%2C%20age%2C%20calculator%2C%20mask%2C%20pose&status=true";

            // 设置请求头
            HttpHeaders headers = new HttpHeaders();
            headers.setContentType(MediaType.APPLICATION_JSON);
            headers.set("x-api-key", VERIFICATION_API_KEY);

            // 将字节数组转换为Base64编码的字符串
            String base64Image = Base64.getEncoder().encodeToString(imageData);

            // 设置请求体
            String requestBody = "{\"file\": \"" + base64Image + "\"}";

            // 发起POST请求
            HttpEntity<String> requestEntity = new HttpEntity<>(requestBody, headers);
            RestTemplate restTemplate = new RestTemplate();
            ResponseEntity<CompreFaceApiResponse> responseEntity = restTemplate.postForEntity(apiUrl, requestEntity, CompreFaceApiResponse.class);

            // 处理响应
            if (responseEntity.getStatusCode().is2xxSuccessful()) {
                CompreFaceApiResponse response = responseEntity.getBody();
                List<CompreFaceApiResponse.Result> faceResults = response.getResult();
                CompreFaceApiResponse.Result result = faceResults.get(0);
                System.out.println("Response: " + result);
                return Result.success(result);
            } else {
                System.err.println("Error: " + responseEntity.getStatusCode());
                return  Result.error("解析失败:" + responseEntity.getStatusCode());
            }
        } catch (Exception e) {
            e.printStackTrace();
            return Result.error("解析失败:" + e.getMessage()) ;
        }
    }

}
