package com.zyh.common.util;

import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Base64;

public class ImageToBase64Converter {

    public static String convertImageToBase64(String imagePath) {
        String base64Image = "";
        Path path = Paths.get(imagePath);

        try {
            byte[] imageBytes = Files.readAllBytes(path);
            base64Image = Base64.getEncoder().encodeToString(imageBytes);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return base64Image;
    }

    public static void main(String[] args) {
        String imagePath = "/path/to/your/image.jpg"; // 替换为实际的图片路径
        String base64Image = convertImageToBase64(imagePath);
        System.out.println(base64Image);
    }
    public static String convertToBase64(MultipartFile image) {
        try {
            byte[] bytes = image.getBytes();
            return Base64.getEncoder().encodeToString(bytes);
        } catch (IOException e) {
            // 处理异常
            e.printStackTrace();
            return null;
        }
    }

    public static String convertBlobToBase64(byte[] blobData) {
        // 使用 Base64 类将字节数组转换为 Base64 编码的字符串
        return Base64.getEncoder().encodeToString(blobData);
    }

}
