//package com.zyh.es.kafka;
//
//import com.zyh.common.domain.CompreFaceApiResponse;
//import com.zyh.es.service.EsService;
//import com.zyh.es.service.impl.EsServicempl;
//import org.apache.kafka.clients.consumer.ConsumerConfig;
//import org.apache.kafka.clients.consumer.ConsumerRecord;
//import org.apache.kafka.clients.consumer.ConsumerRecords;
//import org.apache.kafka.clients.consumer.KafkaConsumer;
//import org.apache.kafka.common.serialization.StringDeserializer;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.stereotype.Service;
//
//import javax.annotation.PostConstruct;
//import java.time.Duration;
//import java.util.Collections;
//import java.util.Properties;
//
//@Service
//public class KafkaConsumerService {
//    private static final String GROUP_ID = "face";
//    private final static String TOPIC = "face";
//
//    @Autowired
//    private EsServicempl esServicempl;
//
//    @PostConstruct
//    public void init() {
//        Properties properties = new Properties();
//        // Kafka服务器地址，多个地址用逗号分隔
//        properties.put(ConsumerConfig.BOOTSTRAP_SERVERS_CONFIG, "152.136.54.230:9092");
//        // 消费者所属的分组ID
//        properties.put(ConsumerConfig.GROUP_ID_CONFIG, GROUP_ID);
//        // 是否自动提交偏移量，默认为true
//        properties.put(ConsumerConfig.ENABLE_AUTO_COMMIT_CONFIG, "true");
//        // 自动提交偏移量的时间间隔
//        properties.put(ConsumerConfig.AUTO_COMMIT_INTERVAL_MS_CONFIG, "1000");
//        // 会话超时时间
//        properties.put(ConsumerConfig.SESSION_TIMEOUT_MS_CONFIG, "30000");
//        // 一次最大拉取的记录数
//        properties.put(ConsumerConfig.MAX_POLL_RECORDS_CONFIG, 1000);
//        // 消费规则，默认earliest
//        properties.put(ConsumerConfig.AUTO_OFFSET_RESET_CONFIG, "earliest");
//        // 键的反序列化器
//        properties.put(ConsumerConfig.KEY_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class);
//        // 值的反序列化器
//        properties.put(ConsumerConfig.VALUE_DESERIALIZER_CLASS_CONFIG, StringDeserializer.class);
//
//        KafkaConsumer<String, CompreFaceApiResponse.Result> kafkaConsumer = new KafkaConsumer<>(properties);
//        // 订阅主题
//        kafkaConsumer.subscribe(Collections.singletonList(TOPIC));
//
//        try {
//            while (true) {
//                // 从Kafka中拉取消息
//                ConsumerRecords<String, CompreFaceApiResponse.Result> records = kafkaConsumer.poll(Duration.ofMillis(100));
//                for (ConsumerRecord<String, CompreFaceApiResponse.Result> record : records) {
//                    // 处理消息
//                    CompreFaceApiResponse.Result data = record.value();
//                    esServicempl.pushToElasticsearch(data);
//                }
//            }
//        } finally {
//            kafkaConsumer.close();
//        }
//    }
//}
