package com.zyh.es.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.zyh.common.domain.CompreFaceApiResponse;
import com.zyh.es.service.EsService;
import org.elasticsearch.action.bulk.BulkRequest;
import org.elasticsearch.action.bulk.BulkResponse;
import org.elasticsearch.action.index.IndexRequest;
import org.elasticsearch.action.index.IndexResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.common.xcontent.XContentType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class EsServicempl implements EsService {
    @Autowired
    private RestHighLevelClient restHighLevelClient;
    @Autowired
    private ObjectMapper objectMapper;


    private final static String INDEX_NAME = "face";


    public void pushToElasticsearch(CompreFaceApiResponse.Result data) {
        try {
            IndexRequest indexRequest = new IndexRequest(INDEX_NAME);

            // 不设置文档 ID，由 Elasticsearch 自动生成一个唯一 ID
            BulkRequest bulkRequest = new BulkRequest();
            bulkRequest.add(
                    new IndexRequest(INDEX_NAME)
                            .source(JSONObject.toJSONString(data), XContentType.JSON)
            );

            BulkResponse bulk = restHighLevelClient.bulk(bulkRequest, RequestOptions.DEFAULT);
            // 可以根据 indexResponse 获取有关索引操作的信息
            System.out.println("Elasticsearch Index Response: " + bulk);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
