package com.zyh.system.controller;

import com.zyh.common.domain.Camera;
import com.zyh.common.result.Result;
import com.zyh.system.service.CameraService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("camera")
public class CameraController {
    @Autowired
    private CameraService cameraService;

    //设备列表
    @PostMapping("/cameraList")
    public Result<List<Camera>> cameraList() {
        return Result.success(cameraService.cameraList());
    }

    //删除设备
    @PostMapping("/cameraDelete")
    public Result cameraDelete(@RequestParam Integer id) {

        return cameraService.cameraDelete(id);
    }

    //添加设备
    @PostMapping("/cameraAdd")
    public Result cameraAdd(@RequestBody Camera camera) {

        return cameraService.cameraAdd(camera);
    }

    //修改设备
    @PostMapping("/cameraUpdate")
    public Result cameraUpdate(@RequestBody Camera camera) {

        return cameraService.cameraUpdate(camera);
    }
}
