//package com.zyh.system.kafka;
//
//import com.fasterxml.jackson.core.JsonProcessingException;
//import com.fasterxml.jackson.databind.ObjectMapper;
//import com.zyh.common.domain.CompreFaceApiResponse;
//import org.apache.kafka.clients.producer.ProducerConfig;
//import org.apache.kafka.clients.producer.ProducerRecord;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.kafka.core.KafkaTemplate;
//import org.springframework.kafka.support.SendResult;
//import org.springframework.stereotype.Service;
//import org.springframework.util.concurrent.ListenableFuture;
//import org.springframework.util.concurrent.ListenableFutureCallback;
//
//import javax.annotation.PostConstruct;
//import java.util.Properties;
//
//@Service
//public class KafkaProducerService {
//
//    @Autowired
//    private KafkaTemplate<String, String> kafkaTemplate;
//
//    private final static String topic="face";
//
//
//    @PostConstruct
//    public void startProducing(CompreFaceApiResponse.Result data) {
//        Properties properties = new Properties();
//        // 设置 Kafka 生产者配置
//        properties.put(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, "152.136.54.230:9092");
//        properties.put("acks", "all");
//        properties.put("retries", 0);
//        properties.put("batch.size", 16384);
//        properties.put(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
//        properties.put(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
//
//        try {
//            // 使用 Jackson 库将对象转换为 JSON 字符串
//            ObjectMapper objectMapper = new ObjectMapper();
//            String jsonString = objectMapper.writeValueAsString(data);
//
//            // 发送 JSON 字符串到 Kafka
//            ListenableFuture<SendResult<String, String>> future = kafkaTemplate.send(topic, jsonString);
//
//            // 添加回调，处理发送结果
//            future.addCallback(new ListenableFutureCallback<>() {
//                @Override
//                public void onSuccess(SendResult<String, String> result) {
//                    // 处理成功的逻辑
//                    System.out.println("消息成功发送到主题: " + result.getRecordMetadata().topic());
//                    System.out.println("消息成功发送到分区: " + result.getRecordMetadata().partition());
//                    System.out.println("消息成功发送到偏移量: " + result.getRecordMetadata().offset());
//                }
//
//                @Override
//                public void onFailure(Throwable ex) {
//                    // 处理失败的逻辑
//                    System.out.println("消息发送失败: " + ex.getMessage());
//                }
//            });
//
//        } catch (JsonProcessingException e) {
//            // 处理转换异常
//            e.printStackTrace();
//            System.out.println("消息发送失败: " + e.getMessage());
//        }
//    }
//}
