package com.zyh.system.service.impl;

import com.zyh.common.domain.Camera;
import com.zyh.common.result.Result;
import com.zyh.common.util.RandomGenerator;
import com.zyh.system.mapper.CameraMapper;
import com.zyh.system.service.CameraService;
import org.apache.commons.lang3.RandomUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Random;

@Service
public class CameraServicempl implements CameraService {
    @Autowired
    private CameraMapper cameraMapper;
    @Override
    public List<Camera> cameraList() {
        List<Camera> cameraList = cameraMapper.cameraList();
        return cameraList;
    }

    @Override
    public Result cameraDelete(Integer id) {
        Integer result = cameraMapper.cameraDelete(id);
        if(result>0){
            return Result.success("删除成功");
        }

        return Result.error("删除失败");
    }

    @Override
    public Result cameraAdd(Camera camera) {
        //五位字母随机
        String s = RandomGenerator.generateRandomLetters(5);
        camera.setCameraId(s);

        Integer result = cameraMapper.cameraAdd(camera);
        if(result>0){
            return Result.success("添加成功");
        }

        return Result.error("添加失败");
    }

    @Override
    public Result cameraUpdate(Camera camera) {

        Integer result = cameraMapper.cameraUpdate(camera);
        if(result>0){
            return Result.success("修改成功");
        }

        return Result.error("修改失败");
    }
}
