package com.zyh.system.service.impl;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.zyh.common.constants.RabbitMQQueueNameConstants;
import com.zyh.common.domain.CompreFaceApiResponse;
import com.zyh.common.result.Result;
import com.zyh.common.util.ComprefaceUtils;
import com.zyh.system.mapper.ComprefaceMapper;
import com.zyh.system.service.ComprefaceService;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.UUID;

@Service
public class ComprefaceServicempl implements ComprefaceService {


    @Autowired
    private ComprefaceMapper comprefaceMapper;
    @Autowired
    private EsServicempl esServicempl;

    @Autowired
    RabbitTemplate rabbitTemplate;
    @Override
    public Result<CompreFaceApiResponse.Result> compareWithSingleFace(MultipartFile targetImage) throws IOException {
        byte[] bytes = targetImage.getBytes();
        // 将接收到的图片路径转换为 base64
        Result<CompreFaceApiResponse.Result> result = ComprefaceUtils.recognizeFace(bytes);
        CompreFaceApiResponse.Result data = result.getData();

//        esServicempl.add(data);
        ObjectMapper objectMapper = new ObjectMapper();
        String jsonString = objectMapper.writeValueAsString(data);

        rabbitTemplate.convertAndSend(RabbitMQQueueNameConstants.SEND_SMS_QUEUE_NAME, jsonString,message -> {

            message.getMessageProperties().setMessageId(UUID.randomUUID().toString().replaceAll("-", ""));
            return message;
        });



        return Result.success(data);
    }


}
