package com.zyh.system.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.zyh.common.domain.CompreFaceApiResponse;
import com.zyh.system.service.EsService;
import org.elasticsearch.action.index.IndexRequest;
import org.elasticsearch.action.index.IndexResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.common.xcontent.XContentType;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class EsServicempl implements EsService {
    @Autowired
    private RestHighLevelClient restHighLevelClient;
    @Autowired
    private ObjectMapper objectMapper;


    private final static String INDEX_NAME = "face";


    public void pushToElasticsearch(CompreFaceApiResponse.Result data) {
        try {
            IndexRequest indexRequest = new IndexRequest(INDEX_NAME);

            // 不设置文档 ID，由 Elasticsearch 自动生成一个唯一 ID
            // indexRequest.id(data.getYourId());

            String jsonData = objectMapper.writeValueAsString(data);
            indexRequest.source(jsonData, XContentType.JSON);

            IndexResponse indexResponse = restHighLevelClient.index(indexRequest, RequestOptions.DEFAULT);

            // 可以根据 indexResponse 获取有关索引操作的信息
            System.out.println("Elasticsearch Index Response: " + indexResponse);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public void add(CompreFaceApiResponse.Result data) {
        try {
            IndexRequest indexRequest = new IndexRequest(INDEX_NAME)
                    .source(JSONObject.toJSONString(data), XContentType.JSON);

            restHighLevelClient.index(indexRequest, RequestOptions.DEFAULT);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


}
